#include "std.h"
#include <stdlib.h>


// ad-hoc hodnota... ak uz bude segment takyto velky, parser test skonci ako neplatny
const int MAX_SIZE_SEGMENT = 330000;


bool test (int size, const char* data)
{
    setDataStream (size, data);
    // testujem len RIFF_AVI/LIST_movi/0?wb|0?dc|0?db
    while (size>=8)
    {
        CMP(8,'0');
        char c1 = GET(8);
        if (IS_VALID())
            if ((c1 < '0') || (c1 > '9'))
                return false;
        char c2 = GET(8);
        char c3 = GET(8);
        if (IS_VALID())
            if (! ((c2 == 'w' && c3 == 'b') || (c2 == 'd' && c3 == 'c') || (c2 == 'd' && c3 == 'b')))
                return false;
        int sizeofSkip = 0;
        for (int i = 0; i < 4; i++)
            sizeofSkip += GET(8)<<8*i;
        if (IS_VALID())
        {
            if (sizeofSkip > MAX_SIZE_SEGMENT)
                return false;
            if (sizeofSkip & 1)
                sizeofSkip += 1;

            g_extraInfo = max (g_extraInfo, sizeofSkip+8);
            size -= sizeofSkip + 8;
            data += sizeofSkip + 8;
            setDataStream (size, data);
        }
        else
            return true;
    }
    return true;
}

int main (int argc, const char* argv[])
{
    assert (argc >= 5);
    bool testResult = false;

    stdOutput_e out = errOpen;
    if (parseAndValidate  (argc, argv))
    {
        out = fail;
        int sizeOfData;
        const char* data;
        getData (sizeOfData, data);
        for (int i = 0; i < g_maxCountOfTests; i++)
        {
            if (testResult = test (::g_sizeofTestedData, data+i))
            {
                out = success;
                break;
            }
        }
    }

    stdOutput (out);
    
    return testResult ? EXIT_SUCCESS : EXIT_FAILURE;
}

